import '../../core/apiResponses.dart';
import '../../domain/entities/user.dart';
import '../../services/toastService.dart';
import '../datasources/login_remote.dart';

class AuthRepository {
  final RemoteLogin remoteLogin;
  //final LocalDataSource localDataSource;

  AuthRepository({
    required this.remoteLogin,
    //required this.localDataSource,
  });

  @override
  Future<User?> login(String email, String password) async {
    try {
      final loginModel = await remoteLogin.remoteloginUser(email, password);
      final user = User.fromModel(loginModel!.userModel);
      //await localDataSource.cacheAuth(Auth);
      return user;
    } on UnauthorizedException {
      showToastError("No autorizado");
      return null;
    } on ServerException {
      showToastError("Error de servidor");
      return null;
    } on Exception {
      showToastError("Error desconocido'");
      return null;
    }
    return null;
  }
}
