import 'dart:io';

import 'package:bloc/bloc.dart';
import 'package:ealu_flutter/data/datasources/login_remote.dart';
import 'package:ealu_flutter/domain/usecases/authentication_case_use.dart';
import 'package:equatable/equatable.dart';

part 'login_event.dart';
part 'login_state.dart';

class LoginBloc extends Bloc<LoginEvent, LoginState> {
  LoginBloc() : super(LoginInitial()) {
    on<LogInRemote>((event, emit) async {
      LoginUseCase authUseCase;
      emit(LoginLoading());
      try {
        var log = await authUseCase.login(event.email, event.password);
        if (log == null) {
          emit(LoginError(""));
        } else {
          emit(LoginLoaded());
        }
      } catch (e) {
        emit(LoginError(""));
      }
    });
    on<LogOutRemote>((event, emit) {});
  }
}
