import 'package:etramite_flutter/clases/GoogleAuth.dart';
import 'package:flutter/material.dart';

class GoogleSignInButton extends StatefulWidget {
  final Function(dynamic token) onGoogleButtomPressed;
  final String contentText;

  const GoogleSignInButton(
      {Key? key,
      required this.onGoogleButtomPressed,
      required this.contentText})
      : super(key: key);

  @override
  _GoogleSignInButtonState createState() => _GoogleSignInButtonState();
}

class _GoogleSignInButtonState extends State<GoogleSignInButton> {
  bool _isSigningIn = false;

  @override
  Widget build(BuildContext context) {
    return Column(
      children: <Widget>[
        if (_isSigningIn == false) ...[
          ElevatedButton(
            style: ElevatedButton.styleFrom(primary: Colors.white),
            onPressed: () async {
              setState(() {
                _isSigningIn = true;
              });

              var usr = await Authentication.signInWithGoogle(context);
              if (usr != null) widget.onGoogleButtomPressed(usr);

              setState(() {
                _isSigningIn = false;
              });
            },
            child: Wrap(
              crossAxisAlignment: WrapCrossAlignment.center,
              children: [
                Image.asset(
                  'assets/google_icon.png',
                  height: 25,
                  width: 25,
                ),
                const SizedBox(
                  width: 15,
                ),
                Text(
                  widget.contentText,
                  style: const TextStyle(fontSize: 16, color: Colors.black),
                ),
              ],
            ),
          ),
        ] else ...[
          CircularProgressIndicator(
            strokeWidth: 2,
            valueColor: AlwaysStoppedAnimation<Color>(
              Theme.of(context).primaryColor,
            ),
          ),
        ],
      ],
    );
  }
}
