//for ios
import 'dart:io';

import 'package:etramite_flutter/services/toastService.dart' as toast;
import 'package:flutter/material.dart';
import 'package:path_provider/path_provider.dart';
import 'package:permission_handler/permission_handler.dart';

//for ios
Future<String> requestAppDocumentsDirectory(BuildContext context) async {
  await getPermision(context);
  var appDocumentsDirectory = await getApplicationDocumentsDirectory();
  return appDocumentsDirectory.path;
}

//for android
Future<String> requestExternalStorageDirectory(BuildContext context) async {
  await getPermision(context);
  /*var externalDocumentsDirectory = ExtStorage.getExternalStoragePublicDirectory(
      ExtStorage.DIRECTORY_DOWNLOADS);*/
  var externalDocumentsDirectory = Directory('/storage/emulated/0/Download');
  /*var externalDocumentsDirectory =
      await getExternalStorageDirectories(type: StorageDirectory.downloads);*/

  //print("Lista de directorios $externalDocumentsDirectory");
  return externalDocumentsDirectory.path;
}

getPermision(BuildContext context) async {
  var status = await Permission.storage.status;
  //print("statussss $status");
  if (status.isGranted) {
    return;
  } else {
    if (status.isLimited) {
      await requestPermision(context);
    } else {
      await requestPermision(context);
    }
  }
}

requestPermision(BuildContext context) async {
  var request = await Permission.storage.request();
  if (request.isGranted) {
    return;
  } else {
    if (request.isDenied || request.isPermanentlyDenied) {
      toast.showToastSuccess(
          "Debe permitir que se acceda al almacenamiento interno");
    } else {
      return;
    }
  }
}

Future<String> getSavePath(BuildContext context) async {
  var directorio = Platform.isIOS
      ? await requestAppDocumentsDirectory(context)
      : await requestExternalStorageDirectory(context);
  String path = directorio;
  //print("directorio, $directorio");
  return path;
}
